{*****************************************************************************
 *
 *  Entering.pas - Form shown when starting
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit Entering;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, GeoGlobal, inifiles;

type
  TOKBottomDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Edit: TEdit;
    Label1: TLabel;

    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    Controller : TForm;
  end;
 var
 OKBottomDlg: TOKBottomDlg;

implementation

uses TestGeo;

{$R *.DFM}

procedure TOKBottomDlg.OKBtnClick(Sender: TObject);

  procedure ReadIni(Towns : TStrings);
  var IniFile :String;
      WindowString : String;
      i : Integer;
  begin
    SetLength(WindowString,MAX_PATH+1);
    i := GetWindowsDirectory(PChar(WindowString),MAX_PATH);
    SetLength(WindowString,i);
    IniFile := WindowString+'geotest.ini';
    ILFileIni := TIniFile.Create(IniFile);
    for i := 0 to Towns.Count-1 do
      MainForm.ListBox.Selected[i] := IlFileIni.ReadBool(User,Towns.Strings[i],false);
    MainForm.TimeTrackBar.Position := IlFileIni.ReadInteger(User,'Time',1500);
    MainForm.TownsTrackBar.Position := IlFileIni.ReadInteger(User,'Bonus',2);
    MainForm.SpinEdit.Value := IlFileIni.ReadInteger(User,'Numquesiti',5);
    MainForm.SoundCheckBox.Checked := IlFileIni.ReadBool(User,'Sound',False);
  end; { ReadIni }

begin
  User := Edit.Text;
  ReadIni(MainForm.Listbox.Items);
  MainForm.Show;
  MainForm.Controller := Self;
  OKBottomDlg.Hide;
end;

procedure TOKBottomDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

end.
