{*****************************************************************************
 *
 *  UQuesiti.pas - Generates questions
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit UQuesiti;

interface
uses GeoGlobal,extctrls,forms,stdctrls,classes,himages,inifiles;

type
  TSession = class(TObject)
               Score : integer;
               RadioQuestions : TRadioGroup;
               NumberOfQuestions : integer;
               ToGuess : SmallInt;
               Tries : SmallInt;
               constructor Init(RadioGroup :TRadioGroup ; Map : THyperImages; ListBox :TListBox);
               function GetNextTown : String;
               procedure DisableTown;
               function GenerateTown(Hyper : THyperImages; ListBox : TListBox): String;
             end;
var
  NQUESTIONS : integer = 5;
  Session : TSession;

function HSDtoTown(HSD : String) : String;

implementation

constructor TSession.Init(RadioGroup :TRadioGroup; Map : THyperImages; ListBox :TListBox);
var i : integer;
    Inserted : boolean;
    S : String;


begin
  inherited Create;
  Score := 0;
  RadioQuestions := RadioGroup;
  ToGuess := NQUESTIONS;
  NumberOfQuestions := NQUESTIONS;
  Tries := 0;
  for i  := 1 to NQUESTIONS do
    repeat
      Inserted := false;
      S := GenerateTown(Map,ListBox);
      if RadioQuestions.Items.IndexOf(S) = -1 then begin
        Inserted  := true;
        RadioQuestions.Items.Add(S);
      end
    until Inserted;
  RadioQuestions.ItemIndex := 0;
end;


function TSession.GetNextTown : String;

  procedure NextEnabled;
  var Di : smallint;
  begin
    Di := NQUESTIONS;
    with RadioQuestions do
      repeat
        if ItemIndex >= NQUESTIONS-1 then ItemIndex := -1;
        ItemIndex := ItemIndex +1;
        dec(Di);
      until (Controls[ItemIndex].Enabled) or (di < 0);
  end;

begin
  Tries := 0;
  if ToGuess > 0 then begin
    NextEnabled;
    result := RadioQuestions.Items[RadioQuestions.ItemIndex];
  end else
    Result := ''
end;

procedure TSession.DisableTown;
begin
  RadioQuestions.Controls[RadioQuestions.ItemIndex].Enabled := False;
  Dec(ToGuess);
end;


function HSDtoTown(HSD : String) : String;
var Index1,Index2: integer;
begin
  Index1 := Pos('/',HSD)+1;
  Index2 := Pos('=',HSD);
  Result := Copy(HSD,index1,index2-index1);
end;

function TSession.GenerateTown(Hyper : THyperImages; ListBox : TListBox): String;
var Town: String;
    Numreg: integer;
    Maxcount : integer;

begin
  Maxcount := 0;
  repeat
    Numreg := random(ListBox.Items.Count);
    inc(maxcount);
    Town := ListBox.Items.Strings[numreg];
  until (not ListBox.Selected[numreg]) or (maxcount > NQUESTIONS*10) ;
  result := Town;
end;

end.
